#! /bin/sh 
# count physical lines and LOC(Lines Of Code) for Sather

total_loc=0
total_l=0

for a in $@ ; do

num_l=`wc $a|gawk '{print $1}'`

num_loc=`
cat $a|gawk '
{
gsub(/--.*/,""); # comment
gsub(/\".*\"/,"string"); # string
gsub(/;/,";\n")
print
}
'|gawk '
{
gsub(/end;/,"");
gsub(/then/,"");
gsub(/else/,"");
gsub(/elsif/,"");
gsub(/[ \t]+/," ");
}
/^[;\t ]*$/{next} # empty line is excluded 
/;/{print }
' |wc|gawk '{print $1}'`

echo $a $num_l $num_loc

total_l=`expr $total_l + $num_l`
total_loc=`expr $total_loc + $num_loc`

done
echo "total lines= " $total_l ", loc= " $total_loc

# end #
