unit event;   { July 5, 1991  programmed by Masaaki Wada }


interface

function keypressed (var c: char): boolean;
function cmdKeyDown: boolean;
function shiftKeyDown: boolean;
function alphaLockDown: boolean;
function optionKeyDown: boolean;

implementation

var
	eventModifiers: integer;

function keypressed (var c: char): boolean;
	var
		theEvent: EventRecord;
	begin
		keypressed := GetNextEvent(keyDownMask, theEvent);
		c := char(LoWord(BitAnd(theEvent.message, charCodeMask)));
		eventModifiers := theEvent.modifiers
	end;

function cmdKeyDown: boolean;
	begin
		cmdKeyDown := (BitAnd(eventModifiers, cmdKey) <> 0)
	end;

function shiftKeyDown: boolean;
	begin
		shiftKeyDown := (BitAnd(eventModifiers, shiftKey) <> 0)
	end;

function alphaLockDown: boolean;
	begin
		alphaLockDown := (BitAnd(eventModifiers, alphaLock) <> 0)
	end;

function optionKeyDown: boolean;
	begin
		optionKeyDown := (BitAnd(eventModifiers, optionKey) <> 0)
	end;

end.